unit fMain;
================================================================================
*       Application:  Clinical Observations
*       Revision:     $Revision: 87 $  $Modtime: 1/14/10 9:26a $
*       Developer:      
*       Site:         Hines OIFO
*       Description:  Primary UI for ICU Flowsheets
*       Notes:
================================================================================
*       $Archive: /CP Modernization/CliO/source/CP Flowsheets/fMain.pas $
================================================================================
interface
uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ComCtrls,
  ExtCtrls,
  StdCtrls,
  CheckLst,
  ActnList,
  Buttons,
  Grids,
  Menus,
  ImgList,
  XPMan,
  XPStyleActnCtrls,
  uGlobalVars,
  ActnMan,
  ActnCtrls,
  ActnMenus,
  ToolWin,
  Math,
  oCliO,
  oCliOTypes,
  oInterfaces,
  Tabs,
  VERGENCECONTEXTORLib_TLB,
  uCCOW,
  CommCtrl,
  HelpIntfs,
  StdStyleActnCtrls,
  u508Dialogs,
  VA508AccessibilityManager,
  SyncObjs;
type
  TfrmMain = class(TForm)
    sBar: TStatusBar;
    ActionManager1: TActionManager;
    acSelectPatient: TAction;
    acAbout: TAction;
    acExit: TAction;
    acHelpContents: TAction;
    acGridView: TAction;
    acReportView: TAction;
    CoolBar1: TCoolBar;
    tBarCommands: TToolBar;
    acLogFilesView: TAction;
    acHL7MonitorView: TAction;
    acSetDateManually: TAction;
    acDatePanBack: TAction;
    acDateExtendBack: TAction;
    acDatePanForward: TAction;
    acDateExtendForward: TAction;
    acDateToday: TAction;
    PopupMenu1: TPopupMenu;
    ExtendDateBack1Day2: TMenuItem;
    PanDateBack1Day2: TMenuItem;
    SetDateRange2: TMenuItem;
    PanDateForward1Day2: TMenuItem;
    ExtendDateForward1Day2: TMenuItem;
    N2: TMenuItem;
    oday000023592: TMenuItem;
    acSwitchView: TAction;
    acUpdateUserSettings: TAction;
    acTimedRefresh: TAction;
    acAlarms: TAction;
    acKardexView: TAction;
    tbSet: TTabSet;
    Bevel4: TBevel;
    tBarViews: TToolBar;
    tbtnKardex: TToolButton;
    tbtnHL7Monitor: TToolButton;
    acCCOWBreakLink: TAction;
    acCCOWRejoin: TAction;
    acCCOWShowStatus: TAction;
    mmMain: TMainMenu;
    mnFile: TMenuItem;
    mnView: TMenuItem;
    mnPeriod: TMenuItem;
    mnHelp: TMenuItem;
    OpenPatient1: TMenuItem;
    UserSettings1: TMenuItem;
    N1: TMenuItem;
    N3: TMenuItem;
    Exit1: TMenuItem;
    Flowsheet1: TMenuItem;
    Alarms1: TMenuItem;
    Kardex1: TMenuItem;
    Reports1: TMenuItem;
    LogFiles1: TMenuItem;
    HL7Monitor1: TMenuItem;
    ExtendDateBack1Day1: TMenuItem;
    PanDateBack1Day1: TMenuItem;
    SetDateRange1: TMenuItem;
    PanDateForward1Day1: TMenuItem;
    ExtendDateForward1Day1: TMenuItem;
    oday000023591: TMenuItem;
    Contents1: TMenuItem;
    About1: TMenuItem;
    BreakLink1: TMenuItem;
    RejoinContext1: TMenuItem;
    ShowCCOWStatus1: TMenuItem;
    vamMainForm: TVA508AccessibilityManager;
    tbtnSelectPatient: TToolButton;
    tbtnDateRange: TToolButton;
    shpViewHeader: TShape;
    Panel1: TPanel;
    pnlPatientNameSexAge: TPanel;
    lblPatientNameSexAge: TLabel;
    Shape1: TShape;
    Shape2: TShape;
    procedure acHL7MonitorViewExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure acSelectPatientExecute(Sender: TObject);
    procedure acAboutExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure sBarDrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel; const Rect: TRect);
    procedure acExitExecute(Sender: TObject);
    procedure acHelpContentsExecute(Sender: TObject);
    procedure acGridViewExecute(Sender: TObject);
    procedure acReportViewExecute(Sender: TObject);
    procedure acLogFilesViewExecute(Sender: TObject);
    procedure acSetDateManuallyExecute(Sender: TObject);
    procedure acDateExtendBackExecute(Sender: TObject);
    procedure acDatePanBackExecute(Sender: TObject);
    procedure acDatePanForwardExecute(Sender: TObject);
    procedure acDateExtendForwardExecute(Sender: TObject);
    procedure acDateTodayExecute(Sender: TObject);
    procedure acSwitchViewExecute(Sender: TObject);
    procedure acUpdateUserSettingsExecute(Sender: TObject);
    procedure acAlarmsExecute(Sender: TObject);
    procedure acKardexViewExecute(Sender: TObject);
    procedure tbSetChange(Sender: TObject; NewTab: Integer; var AllowChange: Boolean);
    procedure tbSetGetImageIndex(Sender: TObject; TabIndex: Integer; var ImageIndex: Integer);
    procedure acCCOWShowStatusExecute(Sender: TObject);
    procedure acCCOWBreakLinkExecute(Sender: TObject);
    procedure acCCOWRejoinExecute(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    fViewList: TStringList;
    fCurrentView: ICPView;
    procedure DisplayControllerMessage(const aMsg: string; aProgress, aProgressMax: integer);
    procedure DateAdjust(aStartDateAdjustment, aStopDateAdjustment: integer);
    procedure AlarmHasFired(Sender: IInterface);
    procedure AlarmWasCleared(Sender: IInterface);
    procedure SetPatient(aPatient: IPatient);
    {CCOW methods}
    procedure CCOWSetCurrentPtIEN(const aPtIEN: string);
    procedure CCOWOkayToChange(var OkayToChange: TVACCOW_AbleToChangeStatus; var MsgText: string);
    procedure CCOWNotifyNewLinkStatus(const aStatus: TVACCOW_LinkStatus);
    procedure CCOWCloseModalForms;
  public
    { Public declarations }
    procedure setPatientDescription(aPatient: IPatient; AlarmCount: Integer);
    //procedure MSG_FS_CLOSE(var Message: TMessage); message FS_CLOSE;
    //procedure MSG_FS_UPDATE_PERIOD(var Message: TMessage); message FS_UPDATE_PERIOD;
    procedure ShutDown;
    function DoHelp(Command: Word; Data: Longint; var CallHelp: Boolean): Boolean;
  end;
var
  frmMain: TfrmMain;
implementation
  DONE: blj 23 Jan 2009 - Need to go to dialogs.pas line 2085 and nick the code to modify for our "MessageDlg508508" function.
{$R *.dfm}
uses
  oDBController_Observations,
  oDBController_Patient,
  oVersionInformation,
  oCPTypes,
  uCP_GUI,
  fAboutDlg,
  fAlarmSettings,
  fSplash,
  fSelectDateRange,
  fPatientLookup,
  mHL7Monitor,
  mReportView,
  mGridView,
  mLogView,
  mAlarmView,
  mTaskView,
  fUserOptions,
  fComment,
  Hash,
  fTimeOutManager,
  VA508AccessibilityRouter,
  fImageList,
  WinHelpViewer;
procedure TfrmMain.FormCreate(Sender: TObject);
var
  aCPView: ICPView;
  i: integer;
begin
  Application.BringToFront;
  My508Manager := vamMainForm;
  ShowSplashScreen;
  UpdateSplashScreen('Loading Application');
  //Application.HelpFile := ChangeFileExt(Application.ExeName, '.hlp');
  SetApplicationHelpFile;
  //Font := Screen.IconFont;
  //shpViewHeader.DoubleBuffered := not ScreenReaderSystemActive;
  InitStatusBar(sBar, MyUser, MyVistALogin);
  sBar.Panels[4].Style := psOwnerDraw;
  sBar.OnDrawPanel := sBarDrawPanel;
  ///MessageDlg(
  //sBar.Panels[3].Text := 'CCOW Status:';
  with TVersionInformation.Create(Application.ExeName, 'MD') do
    try
      //getFileVersion;
      MyApplicationSource := Format('%s (%s)', [getFileNameAndVersion, getCRC32]);
    finally
      Free;
    end;
  MyUserOptions := NewCPUserOptions(MyVistALogin);
  MyUserOptions.Load;
  //MyCPParameters := NewCPParameters(MyVistALogin);
  //MyCPParameters.Load;
  //ShowMessage('You are running build number ' + MyCPParameters.getCurrentApplicationVersion);
  UpdateSplashScreen('Connecting to patient service');
  MyPatientSource := NewDBController_Patient;
  MyPatientSource.Initialize(CONTROLLER_NAME[ctVistA], MyVistALogin);
  MyPatientSource.Load;
  MyPersonService := NewPersonService(MyVistALogin);
  UpdateSplashScreen('Connecting to terminology service');
  NewTerminology.QueryInterface(ITerminology, MyTerminology);
  MyTerminology.Initialize(CONTROLLER_NAME[ctTerminology], MyVistALogin);
  MyTerminology.SetCaching(MyCPParameters.getTerminologyCacheConnectionString);
  UpdateSplashScreen('Loading terminology');
  MyTerminology.Load;
  UpdateSplashScreen('Connecting to CliO service');
  MyCliOService := NewCliOService(MyTerminology);
  MyCliOService.Initialize(CONTROLLER_NAME[ctObservation], MyVistALogin);
  //MyObservationSource.OnNotifyControllerStatus := DisplayControllerMessage;
  MyCliOLoader := MyCliOService.getNewLoader;
  MyCliOLoader.SetOnNotify(DisplayControllerMessage);
  MyCliOLoader.SetLoadAtATime(MyCPParameters.getBatchLoadSize);
  MyCliOList := MyCliOLoader.CreateNewList;
  MyCPService := NewCPService(MyTerminology, MyPersonService);
  MyCPService.Initialize(CONTROLLER_NAME[ctVista], MyVistaLogin);
  MyCPService.Load;
  //MyCPKardex := NewCPKardexService(MyTerminology, MyCPService);
  //MyCPKardex.Initialize('KARDEX', MyVistaLogin);
  MyAlarmList := NewAlarmList(MyVistALogin, MyTerminology);
  MyAlarmList.OnCliOAlarmSet := AlarmHasFired;
  MyAlarmList.OnCliOAlarmClear := AlarmWasCleared;
  MyCliOFiler := MyCliOService.getNewFiler;
  MyCliOFiler.SetAlarmList(MyAlarmList);
  {Build page applicable frames into fViewList}
  fViewList := TStringList.Create;
  fViewList.AddObject(CP_PAGE_FLOWSHEETS, NewGridViewFrame(Self));
  fViewList.AddObject(CP_PAGE_ALARMS, NewAlarmViewFrame(Self, NewAlarmList(MyVistALogin, MyTerminology)));
  fViewList.AddObject(CP_PAGE_REPORTS, NewReportViewFrame(Self));
  fViewList.AddObject(CP_PAGE_LOG_FILES, NewLogViewFrame(Self));
  if MyUser.HasRole(ROLE_CLIO_HL7_ADMINISTRATOR) then
    fViewList.AddObject(CP_PAGE_HL7_MONITOR, NewHL7MonitorFrame(Self, MyCliOLoader.CreateNewHL7Log));
  for i := 0 to fViewList.Count - 1 do
    if fViewList.Objects[i].GetInterface(ICPView, aCPView) then
      aCPView.ViewInitialize;
  (* build the tabs *)
  tbset.OnChange := nil;
  tbSet.Tabs.Clear;
  tbSet.Tabs.AddObject(acGridView.Caption, acGridView);
  acGridView.Enabled := True;
  tbSet.Tabs.AddObject(acAlarms.Caption, acAlarms);
  acAlarms.Enabled := True;
  tbSet.Tabs.AddObject(acReportView.Caption, acReportView);
  acReportView.Enabled := True;
  tbSet.Tabs.AddObject(acLogFilesView.Caption, acLogFilesView);
  acLogFilesView.Enabled := True;
  if MyUser.HasRole(ROLE_CLIO_HL7_ADMINISTRATOR) then
  begin
    tbSet.Tabs.AddObject(acHL7MonitorView.Caption,acHL7MonitorView);
  end
  else
  begin
    acHL7MonitorView.Visible := false;
  end;
  (* Tabsets loaded *)
  (* Kardex not released with this version *)
  acKardexView.Enabled := False;
  tbtnKardex.Visible := False;
  acSwitchViewExecute(nil);
  acDateToday.Execute;
  {Apply the Look and Feel}
  //pnlViewSelector.Visible := (MyUserOptions.getLookAndFeel = lfCPToolBar);
  //CoolBar1.Visible := (MyUserOptions.getLookAndFeel = lfCPToolBar);
  if MyUserOptions.getLookAndFeel = lfClassicCPRS then
    begin
      CoolBar1.Bands[1].Visible := False;
      tbSet.Visible := True;
      tbSet.OnChange := tbSetChange;
    end
  else
    begin
      CoolBar1.Bands[1].Visible := True;
      tbSet.Visible := false;
      tbSet.OnChange := nil;
      acSwitchViewExecute(fViewList.Objects[fViewList.IndexOf(CP_PAGE_FLOWSHEETS)]);
    end;
  SetPatient(nil);
  {Init timout form from IUser.getTimeOut}
  InitTimeOut(Self.ShutDown);
  UpdateTimeOutInterval(MyUser.getTimeOut);
  if Assigned(MyCCOWContextor) then
    begin
      MyCCOWContextor.SetCCOWPatientContextItem(MyUser.getCCOWDFNItemName);
      MyCCOWContextor.SetCCOWNotifyNewPatientID(CCOWSetCurrentPtIEN);
      MyCCOWContextor.SetCCOWNotifyNewLinkStatus(CCOWNotifyNewLinkStatus);
      MyCCOWContextor.SetCCOWNotifyAbleToChange(CCOWOkayToChange);
      MyCCOWContextor.CCOWContextRefresh;
    end;
  acCCOWBreakLink.Visible := Assigned(MyCCOWContextor);
  acCCOWRejoin.Visible := Assigned(MyCCOWContextor);
  acCCOWShowStatus.Visible := Assigned(MyCCOWContextor);
  FreeSplashScreen;
  Show;
  Application.BringToFront;
  BringToFront;
  SetFocus;
  Invalidate;
  Application.ProcessMessages;
  if not Assigned(MyPatient) then
    acSelectPatient.Execute;
end;
procedure TfrmMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  HelpContext: Integer;
begin
  {
  if Key = VK_F1 then
    acHelpContents.Execute;
  }
  if (Key = VK_F1) and assigned(fCurrentView) then
  begin
    Application.HelpCommand(HELP_CONTEXT, fCurrentView.ViewHelpContext);
  end;
end;
procedure TfrmMain.DisplayControllerMessage(const aMsg: string; aProgress, aProgressMax: integer);
begin
  if aProgressMax > 0 then
    sBar.Panels[4].Text := Format('%s %d%%', [aMsg, trunc((aProgress / aProgressMax) * 100)])
  else
    sBar.Panels[4].Text := Format('%s', [aMsg]);
  sBar.Invalidate;
  Application.ProcessMessages;
end;
function TfrmMain.DoHelp(Command: Word; Data: Integer;
  var CallHelp: Boolean): Boolean;
begin
  result := Application.HelpCommand(Command, Data);
  CallHelp := false;
end;
procedure TfrmMain.sBarDrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel; const Rect: TRect);
begin
  if Panel.Style = psOwnerDraw then
    case Panel.Index of
      3:
        if Assigned(MyCCOWContextor) then
          begin
            frmImageList.ilApplicationImages16.Draw(StatusBar.Canvas, Rect.Left + 1, Rect.Top + 1,
              CCOW_BASE + Ord(MyCCOWContextor.CCOWLinkStatus));
            StatusBar.Canvas.TextOut(Rect.Left + 20, Rect.Top + 3,
              CCOW_LINK_STATUS[MyCCOWContextor.CCOWLinkStatus]);
          end
        else
          begin
            frmImageList.ilApplicationImages16.Draw(StatusBar.Canvas, Rect.Left + 1, Rect.Top + 1,
              CCOW_NONE);
            StatusBar.Canvas.TextOut(Rect.Left + 20, Rect.Top + 3,
              CCOW_LINK_STATUS[lsNoCCOW]);
          end;
      4:
        begin
          if Panel.Text = '' then
            begin
              frmImageList.ilApplicationImages16.Draw(StatusBar.Canvas, Rect.Left + 1, Rect.Top + 1, LV_GROUPER_SML);
              StatusBar.Canvas.TextOut(Rect.Left + 20, Rect.Top + 3, 'Ready');
            end
          else
            begin
              frmImageList.ilApplicationImages16.Draw(StatusBar.Canvas, Rect.Left + 1, Rect.Top + 1, BTN_WORKING);
              StatusBar.Canvas.TextOut(Rect.Left + 20, Rect.Top + 3, Panel.Text);
            end
        end;
    end
  else
    StatusBar.Canvas.TextRect(Rect, Rect.Left + 20, Rect.Top + 3, Panel.Text);
end;
procedure TfrmMain.setPatientDescription(aPatient: IPatient; AlarmCount: Integer);
const
  ALARM_TXT = '%d alarm(s) active';
var
  AlarmText: string;
begin
  if AlarmCount > -1 then
    AlarmText := Format(ALARM_TXT, [AlarmCount])
  else
    AlarmText := '';
  if Assigned(aPatient) then
    begin
      //lblPatientDemographics.Font.Style := [fsBold];
      lblPatientNameSexAge.Caption :=
        MyPatient.getDisplayLine(1) + #13#10 +
        AlarmText + #13#10 +
        MyPatient.getDisplayLine(2) + #13#10 +
        MyPatient.getDisplayLine(3);
    end
  else
    begin
      //lblPatientDemographics.Font.Style := [];
      lblPatientNameSexAge.Caption := 'No Patient Selected';
    end;
end;
procedure TfrmMain.SetPatient(aPatient: IPatient);
begin
  acAlarms.ImageIndex := IMAGE_ALARMS_INACTIVE;
  acGridView.Enabled := False;
  acAlarms.Enabled := False;
  acReportView.Enabled := False;
  acLogFilesView.Enabled := False;
  acKardexView.Enabled := False;
  Kardex1.Visible := False;
  acHL7MonitorView.Enabled := False;
  tbSet.Enabled := False;
  MyPatient := aPatient;
  if Assigned(MyPatient) then
    begin
      (* Ok, trying out something here :::::: *)
      //tbset.OnChange := nil;
      //tbSet.Tabs.Clear;
      { This goofy way prevents the firing until we're ready :) }
      //tbSet.Tabs.AddObject(acGridView.Caption, acGridView);
      //acGridView.Enabled := True;
      //tbSet.Tabs.AddObject(acAlarms.Caption, acAlarms);
      //acAlarms.Enabled := True;
      MyAlarmList.Load(MyPatient.getDFN);
      if MyAlarmList.getActivatedAlarmCount > 0 then
        acAlarms.ImageIndex := IMAGE_ALARMS_ACTIVE
      else
        acAlarms.ImageIndex := IMAGE_ALARMS_INACTIVE;
      //acKardexView.Enabled := False;
      //tbtnKardex.Visible := False;
      {
      if MyPatient.getWardLocation <> '' then
        begin
          if MyCPParameters.getUseKardex(MyPatient.getWardLocation) then
            begin
              MyCPKardex.Load(MyPatient, MyStartDateTime, MyStopDateTime);
              acKardexView.Enabled := True;
              tbSet.Tabs.AddObject(acKardexView.Caption, acKardexView);
              tbtnKardex.Visible := True;
              Kardex1.Visible := True;
            end
          else
            begin
              tbSet.Tabs.Add(acKardexView.Caption);
              acKardexView.Enabled := false;
            end;
        end
      else
        begin
          tbSet.Tabs.Add(acKardexView.Caption);
          acKardexView.Enabled := false;
        end;
      }
      //tbSet.Tabs.AddObject(acReportView.Caption, acReportView);
      //tbSet.Tabs.AddObject(acLogFilesView.Caption, acLogFilesView);
//      acReportView.Enabled := True;
//      acLogFilesView.Enabled := True;
//
//      acHL7MonitorView.Enabled := False;
      //tbtnHL7Monitor.Visible := False;
      //if MyUser.HasRole(ROLE_CLIO_HL7_ADMINISTRATOR) then
      //  begin
      //    acHL7MonitorView.Enabled := True;
      //    tbtnHL7Monitor.Visible := True;
      //    tbSet.Tabs.AddObject(acHL7MonitorView.Caption, acHL7MonitorView);
      //  end;
      tbSet.TabIndex := 0;
      tbset.OnChange := tbSetChange;
      tbSet.Enabled := True;
      if MyUserOptions.getLookAndFeel = lfClassicCPRS then
        begin
          tbset.Visible := true;
          tbSet.OnChange := tbSetChange;
        end
      else
        begin
          tbSet.Visible := false;
          tbSet.OnChange := nil;
        end;
      tbset.Invalidate;
      if not Assigned(fCurrentView) then
        acGridView.Execute
      else
        fCurrentView.ViewActivate;
    end
  else
    begin
      //lblPatientDemographics.Font.Style := [fsBold];
      lblPatientNameSexAge.Caption := 'No Patient Selected';
    end;
  if assigned(MyAlarmList) then
    setPatientDescription(MyPatient, MyAlarmList.getActivatedAlarmCount)
  else
    setPatientDescription(MyPatient, -1);
  acGridView.Enabled := (Assigned(MyPatient));
  acAlarms.Enabled := (Assigned(MyPatient));
  acReportView.Enabled := (Assigned(MyPatient));
  acLogFilesView.Enabled := (Assigned(MyPatient));
  acHL7MonitorView.Enabled := (Assigned(MyPatient));
  tbSet.Enabled := (Assigned(MyPatient));
end;
procedure TfrmMain.tbSetChange(Sender: TObject; NewTab: Integer; var AllowChange: Boolean);
begin
  tbSet.Enabled := False; {Turn off the tabs until we get swiched up}
  try
    if not (acKardexView.Enabled) and
      (tbSet.Tabs[NewTab] = acKardexView.Caption) then
      begin
        MessageDlg508('Kardex disabled for this location and patient.', mtError, [mbOK], 0);
        AllowChange := false;
        exit;
      end;
    if Sender <> nil then
      acSwitchViewExecute(fViewList.Objects[NewTab]);
    AllowChange := True;
  except
    on E: Exception do
      begin
        MessageDlg508('Error accessing method for tab' + #13#10 + E.message, mtError, [mbOk], 0);
        AllowChange := False;
      end;
  end;
  tbSet.Enabled := True;
end;
procedure TfrmMain.tbSetGetImageIndex(Sender: TObject; TabIndex: Integer; var ImageIndex: Integer);
begin
  try
    if tbSet.Tabs.Objects[TabIndex] <> nil then
      ImageIndex := TAction(tbset.Tabs.Objects[TabIndex]).ImageIndex
    else
      if tbset.Tabs[TabIndex] = '&Kardex' then
        ImageIndex := 5
      else
        ImageIndex := -1;
  except
    ImageIndex := -1;
  end;
  if ImageIndex = 0 then
    ImageIndex := 10;
end;
{------------------------------------------------------------------------------}
{------------------------ TActionList methods ---------------------------------}
{------------------------------------------------------------------------------}
procedure TfrmMain.acSelectPatientExecute(Sender: TObject);
var
  PatientAssigned: boolean;
begin
  PatientAssigned := false;
  with NewPatientLookupForm(MyPatientSource, MyUserOptions.getDefaultLocationID) do
    try
      if Execute then
        begin
          if assigned(MyCCOWContextor) then
          begin
            MyCCOWContextor.SetCCOWPatientContextID(getCurrentPatient.getDFN);
            PatientAssigned := getCurrentPatient <> nil;
          end
          else
            SetPatient(getCurrentPatient);
        end;
    finally
      Free;
    end;
    acCCOWBreakLink.Enabled := PatientAssigned;
    acCCOWRejoin.Enabled := PatientAssigned;
    acCCOWShowStatus.Enabled := PatientAssigned;
end;
procedure TfrmMain.acAboutExecute(Sender: TObject);
begin
  AboutDlg.Execute;
end;
procedure TfrmMain.acExitExecute(Sender: TObject);
begin
  acCCOWBreakLink.Execute;
  Close;
end;
procedure TfrmMain.acHelpContentsExecute(Sender: TObject);
begin
  try
    Application.HelpCommand(HELP_CONTENTS, 0);
  except
    on E: Exception do
      MessageDlg508(E.Message + #13#10 +
        '"' + Application.HelpFile + '"', mtError, [mbOK], 0);
  end;
end;
procedure TfrmMain.acSwitchViewExecute(Sender: TObject);
var
  i: integer;
  procedure ClearMainMenu(aMenu: TMainMenu);
  var
    mi: TMenuItem;
    i: integer;
  begin
    i := 4;
    while i <= aMenu.Items.Count - 1 do
      begin
        mi := aMenu.Items[i];
        aMenu.Items.Delete(i);
        if assigned(mi) then
          FreeAndNil(mi);
      end;
  end;
begin
  Enabled := false;
  try
    if Assigned(fCurrentView) then
      begin
        I := mmMain.Items.IndexOf(fCurrentView.ViewMenu);
        if I > -1 then
          mmMain.Items.Delete(I);
        fCurrentView.ViewDeactivate;
        fCurrentView := nil;
      end;
    MyAlarmList.Refresh;
    if tbSet.Visible then
      begin
        I := fViewList.IndexOfObject(Sender);
        if I > -1 then
          begin
            tbSet.OnChange := nil;
            tbSet.TabIndex := I;
            tbSet.OnChange := tbSetChange;
          end;
      end;
    if MyAlarmList.getActivatedAlarmCount > 0 then
      acAlarms.ImageIndex := IMAGE_ALARMS_ACTIVE
    else
      acAlarms.ImageIndex := IMAGE_ALARMS_INACTIVE;
    if Assigned(Sender) then
      if Sender.GetInterface(ICPView, fCurrentView) then
        begin
          fCurrentView.ViewActivate;
          mmMain.Items.Insert(mmMain.Items.Count - 1, fCurrentView.ViewMenu);
        end
      else
        ShowMessageFmt('OOPS, ''%s'' doesn''t support ICPView', [Sender.ClassName]);
  finally
    Enabled := true;
  end;
end;
procedure TfrmMain.acUpdateUserSettingsExecute(Sender: TObject);
begin
  UpdateUserSettings(MyUser, MyUserOptions);
  //tBarViews.Visible := (MyUserOptions.getLookAndFeel = lfCPToolBar);
  CoolBar1.Bands[1].Visible := MyUserOptions.getLookAndFeel = lfCPToolBar;
  //pnlViewSelector.Visible := (MyUserOptions.getLookAndFeel = lfCPToolBar);
  if MyUserOptions.getLookAndFeel = lfClassicCPRS then
    begin
      tbSet.Visible := true;
      tbSet.OnChange := tbSetChange;
    end
  else
    begin
      tbSet.Visible := false;
      tbSet.OnChange := nil;
    end;
  frmMain.Repaint;
end;
procedure TfrmMain.AlarmHasFired(Sender: IInterface);
var
  aCliOAlarm: ICliOAlarm;
begin
  if Sender.QueryInterface(ICliOAlarm, aCliOAlarm) = 0 then
    begin
      MessageDlg508(
        'An alarm has been triggered.' + #13 + #13 +
        aCliOAlarm.GetAlarm + #13 + #13 + 'Instructions: ' +
        aCliOAlarm.getActivationComment,
        mtConfirmation, [mbOk], 0);
      acAlarms.ImageIndex := IMAGE_ALARMS_ACTIVE;
      tbSet.Refresh;
    end;
  MyAlarmList.Refresh;
  SetPatientDescription(MyPatient, MyAlarmList.getActivatedAlarmCount);
end;
procedure TfrmMain.AlarmWasCleared(Sender: IInterface);
begin
  MyAlarmList.Refresh;
  if MyAlarmList.getActivatedAlarmCount = 0 then
    begin
      acAlarms.ImageIndex := IMAGE_ALARMS_INACTIVE;
      tbSet.Refresh;
    end
  else
    begin
      acAlarms.ImageIndex := IMAGE_ALARMS_ACTIVE;
      tbSet.Refresh;
    end;
  SetPatientDescription(MyPatient, MyAlarmList.getActivatedAlarmCount);
end;
(******************************************************************************)
(*********************************  CCOW  *************************************)
(******************************************************************************)
procedure TfrmMain.acCCOWBreakLinkExecute(Sender: TObject);
begin
  if Assigned(MyCCOWContextor) then
    try
      Screen.Cursor := crHourGlass;
      MyCCOWContextor.CCOWContextSuspend;
    finally
      Screen.Cursor := crDefault;
    end;
end;
procedure TfrmMain.acCCOWRejoinExecute(Sender: TObject);
begin
  if Assigned(MyCCOWContextor) then
    try
      Screen.Cursor := crHourGlass;
      MyCCOWContextor.SetCCOWPatientContextID(MyPatient.getDFN);
      MyCCOWContextor.CCOWContextResume(rmSet);
    finally
      Screen.Cursor := crDefault;
    end;
end;
procedure TfrmMain.acCCOWShowStatusExecute(Sender: TObject);
var
  aMsg: string;
begin
  if not Assigned(MyCCOWContextor) then
    aMsg := 'CCOW is not current active for this application'
  else
    aMsg := Format('Current CCOW status is ''%s''', [CCOW_LINK_STATUS[MyCCOWContextor.CCOWLinkStatus]]);
  MessageDlg508(aMsg, mtInformation, [mbOk], 0);
end;
procedure TfrmMain.CCOWCloseModalForms;
var
  i: integer;
begin
  for i := Screen.FormCount - 1 downto 1 do
    begin
      { Close all modal dialogs and message boxes that are displayed
        over the this window (main application window). }
      if Screen.Forms[i] <> Self then
        if fsModal in Screen.Forms[i].FormState then
          Screen.Forms[i].ModalResult := mrCancel
        else
          Screen.Forms[i].Close;
    end;
end;
procedure TfrmMain.CCOWSetCurrentPtIEN(const aPtIEN: string);
begin
  CCOWCloseModalForms;
  setPatient(MyPatientSource.getPatient(aPtIEN));
end;
procedure TfrmMain.CCOWNotifyNewLinkStatus(const aStatus: TVACCOW_LinkStatus);
begin
  //sBar.Panels[3].Text := IntToStr(Ord(aStatus));
end;
procedure TfrmMain.CCOWOkayToChange(var OkayToChange: TVACCOW_AbleToChangeStatus; var MsgText: string);
begin
  CCOWCloseModalForms;
  OkayToChange := acYes;
end;
(******************************************************************************)
(************************  Date/Time Adjusterators  ***************************)
(******************************************************************************)
procedure TfrmMain.DateAdjust(aStartDateAdjustment, aStopDateAdjustment: integer);
  function getRangeString: string;
  begin
    Result :=
      FormatDateTime('YYYY-MM-DD hh:mm', MyStartDateTime) +
      ' to ' +
      FormatDateTime('YYYY-MM-DD hh:mm', MyStopDateTime);
  end;
begin
  MyStartDateTime := MyStartDateTime + aStartDateAdjustment;
  MyStopDateTime := MyStopDateTime + aStopDateAdjustment;
  tbtnDateRange.Caption := getRangeString;
  if Assigned(fCurrentView) then
    fCurrentView.ViewReload;
end;
procedure TfrmMain.acSetDateManuallyExecute(Sender: TObject);
begin
  if GetDateRange(MyStartDateTime, MyStopDateTime, True) then
    DateAdjust(0, 0);
end;
procedure TfrmMain.acDateExtendBackExecute(Sender: TObject);
begin
  DateAdjust(-1, 0);
end;
procedure TfrmMain.acDateExtendForwardExecute(Sender: TObject);
begin
  DateAdjust(0, 1);
end;
procedure TfrmMain.acDatePanBackExecute(Sender: TObject);
begin
  DateAdjust(-1, -1);
end;
procedure TfrmMain.acDatePanForwardExecute(Sender: TObject);
begin
  DateAdjust(1, 1);
end;
procedure TfrmMain.acDateTodayExecute(Sender: TObject);
begin
  MyStartDateTime := trunc(Now);
  MyStopDateTime := MyStartDateTime + EncodeTime(23, 59, 59, 00);
  DateAdjust(0, 0);
end;
(******************************************************************************)
(**************************** Page Switchers **********************************)
(******************************************************************************)
procedure TfrmMain.acAlarmsExecute(Sender: TObject);
begin
  acSwitchViewExecute(fViewList.Objects[fViewList.IndexOf(CP_PAGE_ALARMS)]);
  Caption := 'CP Flowsheets: Alarms';
end;
procedure TfrmMain.acHL7MonitorViewExecute(Sender: TObject);
begin
  acSwitchViewExecute(fViewList.Objects[fViewList.IndexOf(CP_PAGE_HL7_MONITOR)]);
  Caption := 'CP Flowsheets: HL7 Monitor';
end;
procedure TfrmMain.acLogFilesViewExecute(Sender: TObject);
begin
  acSwitchViewExecute(fViewList.Objects[fViewList.IndexOf(CP_PAGE_LOG_FILES)]);
  Caption := 'CP Flowsheets: Log Files';
end;
procedure TfrmMain.acGridViewExecute(Sender: TObject);
begin
  acSwitchViewExecute(fViewList.Objects[fViewList.IndexOf(CP_PAGE_FLOWSHEETS)]);
  Caption := 'CP Flowsheets: Flowsheet';
end;
procedure TfrmMain.acReportViewExecute(Sender: TObject);
begin
  acSwitchViewExecute(fViewList.Objects[fViewList.IndexOf(CP_PAGE_REPORTS)]);
  Caption := 'CP Flowsheets: Reports';
end;
procedure TfrmMain.acKardexViewExecute(Sender: TObject);
begin
  acSwitchViewExecute(fViewList.Objects[fViewList.IndexOf(CP_PAGE_CARE_ACTIONS)]);
  Caption := 'CP Flowsheets: Kardex';
end;
(******************************************************************************)
(**************************** Page Switchers **********************************)
(******************************************************************************)
procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if MyUserOptions.getConfirmOnClose then
    CanClose := (MessageDlg508('Close CPFlowsheet Application?', mtConfirmation, mbYesNo, 0) <> mrNo)
  else
    CanClose := True;
end;
procedure TfrmMain.ShutDown;
var
  i: Integer;
begin // Close all modal forms here
  for i := 0 to Screen.CustomFormCount - 1 do
    begin
      if Screen.CustomForms[i] = self then
        continue;
      if fsModal in Screen.CustomForms[i].FormState then
        begin
          Screen.CustomForms[i].ModalResult := mrCancel;
          Screen.CustomForms[i].Close;
        end;
    end;
  Application.Terminate;
end;
(*
procedure TfrmMain.MSG_FS_CLOSE(var Message: TMessage);
begin
  Close;
end;
procedure TfrmMain.MSG_FS_UPDATE_PERIOD(var Message: TMessage);
begin
  {
    lblDateRange.Caption :=
      FormatDateTime('YYYY-MM-DD hh:mm', MyStartDateTime) +
      ' to ' +
      FormatDateTime('YYYY-MM-DD hh:mm', MyStopDateTime);
    setPatientDescription(MyPatient);
  }
end;
*)
initialization
  SpecifyFormIsNotADialog(TfrmMain);
end.
