unit oFMFile;

interface

uses
  Classes,
  Dialogs,
  XMLDoc,
  XMLIntf,
  oMyBroker,
  SysUtils;

type
  TFMFile = class(TObject)
  private
    fName: string;
    fNumber: string;
    fRoot: string;
    fFields: TStringList;
  public
    procedure LoadFields(aBroker: TMyBroker);
    procedure AssignFields(aList: TStrings);
    property Name: string read fName;
    property Number: string read fNumber;
    property Root: string read fRoot;
    property Fields: TStringList read fFields;
  end;

function NewFMFile(aXMLNode: IXMLNode): TFMFile;

implementation

uses
  oFMField;

function NewFMFile(aXMLNode: IXMLNode): TFMFile;
begin
  Result := TFMFile.Create;
  with Result do
    try
      fFields := TStringList.Create;
      fName := aXMLNode.Attributes['NAME'];
      fNumber := aXMLNode.Attributes['NUMBER'];
      fRoot := aXMLNode.Attributes['ROOT'];
    except
      FreeAndNil(Result);
    end;
end;

{ TFMFile }

procedure TFMFile.AssignFields(aList: TStrings);
var
  i: integer;
begin
  aList.Clear;
  //
end;

procedure TFMFile.LoadFields(aBroker: TMyBroker);
var
  aNode: IXMLNode;
  aFld: TFMField;
begin
  if fFields.Count = 0 then
    begin
      fFields := TStringList.Create;
      aBroker.CallServer(['GETFLDS', fNumber], nil);
      with NewXMLDocument do
        begin
          XML.Text := aBroker.Results.Text;
          Active := True;
          aNode := DocumentElement.ChildNodes.FindNode('FIELDLIST');
          if aNode <> nil then
            begin
              aNode := aNode.ChildNodes.First;
              while aNode <> nil do
                begin
                  aFld := NewFMField(aNode);
                  if aFld <> nil then
                    fFields.AddObject(aFld.DescriptiveName, aFld);
                  aNode := aNode.NextSibling;
                end;
            end;
        end;
    end;
end;

end.

