unit fEditTermPairRanking;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ComCtrls,
  XMLDoc,
  XMLIntf,
  ExtCtrls,
  iCPTerminology;

type
  TfrmEditTermPairRanking = class(TForm)
    Label1: TLabel;
    btnCancel: TButton;
    btnOK: TButton;
    lblDescription: TLabel;
    Shape1: TShape;
    lblValidation: TLabel;
    Bevel1: TBevel;
    memEdit: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure edtValueChange(Sender: TObject);
    procedure memEditEnter(Sender: TObject);
  private
  public
    { Public declarations }
  end;

function EditTermPair(aPair: ITermQualifierPair): boolean;

implementation

uses
  uGlobalVars;

{$R *.dfm}

function EditTermPair(aPair: ITermQualifierPair): boolean;
begin
  with TfrmEditTermPairRanking.Create(Application) do
    try
      Caption := Format('Update %s', [TERM_TYPE_DISPLAY[aPair.getPairType]]);
      lblDescription.Caption :=
        Format(
        'Enter the resulting value whenever the term %s is paired with the observation %s.' + #13 + #13 +
        'This value will be used in calculations and rankings for this pairing.',
        [aPair.getComponentTerm.getTerm, aPair.getParentTerm.getTerm]);

      lblValidation.Caption := 'Description:';
      lblValidation.Font.Style := [fsBold];

      Label1.Caption :=
        Format('%s Value:', [TERM_TYPE_DISPLAY[aPair.getPairType]]);

      //edtValue.Text := FloatToStr(aPair.getRanking);
      memEdit.Text := FloatToStr(aPair.getRanking);

      if (ShowModal = mrOK) then
        begin
          aPair.setRanking(StrToFloat(memEdit.Text));
          aPair.setRanking(StrToFloat(memEdit.Text));
          Result := True;
        end
      else
        Result := False;
    finally
      Free;
    end;
end;

procedure TfrmEditTermPairRanking.edtValueChange(Sender: TObject);
begin
  try
    StrToFloat(memEdit.Text);
    btnOk.Enabled := True;
    btnOk.Default := True;
  except
    btnOk.Enabled := False;
    btnOk.Default := False;
  end;
end;

procedure TfrmEditTermPairRanking.FormCreate(Sender: TObject);
begin
  lblValidation.Font.Style := [fsBold];
  memEdit.Text := '0.0';
  btnOK.Enabled := False;
end;

procedure TfrmEditTermPairRanking.memEditEnter(Sender: TObject);
begin
  memEdit.SelLength := Length(memEdit.Lines.Text);
end;

end.

