unit fErrorLog;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ExtCtrls,
  iCPTerminology,
  uGlobalVars,
  ComCtrls;

type
  TfrmErrorLog = class(TForm)
    Shape1: TShape;
    lblType: TLabel;
    btnOK: TButton;
    btnSave: TButton;
    dlgSave: TSaveDialog;
    memLog: TMemo;
    procedure btnSaveClick(Sender: TObject);
  public
    { Public declarations }
  end;

procedure ViewErrorLog(aLog: TStrings);

implementation

{$R *.dfm}

procedure ViewErrorLog(aLog: TStrings);
begin
  with TfrmErrorLog.Create(Application) do
    try
      Font := Screen.IconFont;
      lblType.Font.Style := [fsBold];
      memLog.Lines.Clear;
      memLog.Lines.AddStrings(aLog);
      ShowModal;
    finally
      Free;
    end;
end;

procedure TfrmErrorLog.btnSaveClick(Sender: TObject);
var
  aPrintOut: TStringList;
begin
  aPrintOut := TStringList.Create;
  with dlgSave do
    try
      FileName := 'Terminology Errors.txt';
      if Execute then
        begin
          aPrintOut.Add(Application.Title);
          aPrintOut.Add('Date Time: ' + DateTimeToStr(Now));
          aPrintout.Add(' ');
          aPrintOut.AddStrings(memLog.Lines);
          aPrintOut.SaveToFile(FileName);
        end;
    except
      on E: Exception do
        ShowMessageFmt('Error: %s', [e.Message]);
    end;
  FreeAndNil(aPrintOut);
end;

end.

