unit fNewTerm;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ExtCtrls,
  iCPTerminology;

type
  TfrmNewTerm = class(TForm)
    Shape1: TShape;
    lblHeader: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    edtTerm: TEdit;
    edtAbbreviation: TEdit;
    edtDisplayName: TEdit;
    cbxTermType: TComboBox;
    cbxDataType: TComboBox;
    Shape2: TShape;
    btnCreate: TButton;
    btnCancel: TButton;
    procedure btnCreateClick(Sender: TObject);
  private
    fNewTerm: ITerm;
  public
    { Public declarations }
  end;

function CreateNewTerm: ITerm;

implementation

uses
  uGlobalVars;

{$R *.dfm}

function CreateNewTerm: ITerm;
begin
  with TfrmNewTerm.Create(Application) do
    try
      lblHeader.Font.Style := [fsBold];
      MyTerminology.LoadTermTypes(cbxTermType.Items);
      MyTerminology.LoadDataTypes(cbxDataType.Items);

      edtTerm.Text := 'NEW TERM';
      edtAbbreviation.Text := 'nt';
      edtDisplayName.Text := 'New Term';
      cbxTermType.ItemIndex := Ord(ttObservation);
      cbxDataType.ItemIndex := Ord(dtNumeric);

      ShowModal;

      if Assigned(fNewTerm) then
        fNewTerm.QueryInterface(ITerm, Result)
      else
        Result := nil;
    finally
      Free;
    end;
end;

procedure TfrmNewTerm.btnCreateClick(Sender: TObject);
begin
  if (edtTerm.Text <> '') and (edtAbbreviation.Text <> '') and (edtDisplayName.Text <> '') then
    begin
      if (cbxTermType.ItemIndex = Ord(ttObservation)) and (cbxDataType.ItemIndex > 0) then
        MyTerminology.getNewTerm(ttObservation, TDataType(cbxDataType.ItemIndex)).QueryInterface(ITerm, fNewTerm)
      else
        MyTerminology.getNewTerm(TTermType(cbxTermType.ItemIndex)).QueryInterface(ITerm, fNewTerm);

      if Assigned(fNewTerm) then
        begin
          fNewTerm.setTerm(edtTerm.Text);
          fNewTerm.setAbbreviation(edtAbbreviation.Text);
          fNewTerm.setDisplayName(edtDisplayName.Text);
          ModalResult := mrOk;
        end;
    end
  else
    MessageDlg('Missing elements, unable to create this term', mtInformation, [mbOk], 0);
end;

end.

