unit mEditFileHeader;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  uGlobalVars,
  Dialogs,
  StdCtrls,
  ComCtrls,
  ExtCtrls,
  iCPTerminology;

type
  TfraEditFileHeader = class(TFrame)
    memDescription: TMemo;
    Label1: TLabel;
    lblDateTimeCreated: TLabel;
    Label3: TLabel;
    lblDateTimeModified: TLabel;
    Label2: TLabel;
    lblType: TLabel;
    Shape1: TShape;
    lblStats: TLabel;
    lvStats: TListView;
    procedure memDescriptionChange(Sender: TObject);
  private
    fLoading: boolean;
  public
    procedure Load;
  end;

function NewEditFileHeaderFrame(aOwner: TWinControl): TfraEditFileHeader;

implementation

{$R *.dfm}

function NewEditFileHeaderFrame(aOwner: TWinControl): TfraEditFileHeader;
begin
  Result := TfraEditFileHeader.Create(aOwner);
  with Result do
    begin
      Parent := aOwner;
      align := alClient;
      lblType.Font.Style := [fsBold];
    end;
end;

{ TfraEditFileHeader }

procedure TfraEditFileHeader.Load;
var
  aType: TTermType;
begin
  fLoading := True;
  memDescription.Lines.Text := MyTerminology.getDescription;
  lblDateTimeCreated.Font.Style := [fsBold];
  lblDateTimeCreated.Caption := FormatDateTime('MMM D, YYYY h:mm am/pm', MyTerminology.getDateTimeCreated);
  lblDateTimeModified.Font.Style := [fsBold];
  lblDateTimeModified.Caption := FormatDateTime('MMM D, YYYY h:mm am/pm', MyTerminology.getDateTimeModified);
  lvStats.Items.Clear;
  for aType := ttObservation to High(TTermType) do
    with lvStats.Items.Add do
      begin
        Caption := TERM_TYPE_DISPLAY[aType];
        SubItems.Add(IntToStr(MyTerminology.getCountByType(aType)));
      end;
  fLoading := False;
end;

procedure TfraEditFileHeader.memDescriptionChange(Sender: TObject);
begin
  if not fLoading then
    MyTerminology.SetDescription(memDescription.Text);
end;

end.

