unit mEditPairs;
================================================================================
*       Application:  Clinical Observations
*       Revision:     $Revision: 20 $  $Modtime: 6/25/09 1:59p $
*       Developer:      
*       Site:         Hines OIFO
*       Description:  Terminology editor.
*       Notes:        THIS APPLICATION IS NOT TO BE RELEASED TO THE FIELD.
*                     ***TERMINOLOGY FILES ARE UNEDITABLE AFTER RELEASE***
================================================================================
*       $Archive: /CP Modernization/CliO/source/CP Terminology Editor/mEditPairs.pas $
================================================================================
interface
uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  CheckLst,
  ExtCtrls,
  ActnList,
  XMLDoc,
  XMLIntf,
  Buttons,
  ImgList,
  Grids,
  ValEdit,
  ComCtrls,
  Menus,
  iCPTerminology;
type
  TfraEditPairs = class(TFrame)
    ActionList1: TActionList;
    acAssign: TAction;
    acRemove: TAction;
    acMoveUp: TAction;
    acMoveDown: TAction;
    ImageList1: TImageList;
    pnlAll: TPanel;
    sbtnAdd: TSpeedButton;
    sbtnRemove: TSpeedButton;
    pnlAssigned: TPanel;
    pnlAddRemove: TPanel;
    pnlUpDown: TPanel;
    sbtnUp: TSpeedButton;
    sbtnDown: TSpeedButton;
    lblType: TLabel;
    bvlBottom: TBevel;
    bvlLeft: TBevel;
    acEditPair: TAction;
    pnlTop: TPanel;
    Image1: TImage;
    acExpandCollapse: TAction;
    pnlMain: TPanel;
    ilMinusPlus: TImageList;
    lbxall: TListBox;
    Bevel1: TBevel;
    acLoadItems: TAction;
    lbxSelected: TListBox;
    acReOrder: TAction;
    acSortAlphabetically: TAction;
    acZeroAll: TAction;
    pmn: TPopupMenu;
    az1: TMenuItem;
    N0n1: TMenuItem;
    N001: TMenuItem;
    acZeroToN: TAction;
    procedure acExpandCollapseExecute(Sender: TObject);
    procedure acLoadItemsExecute(Sender: TObject);
    procedure acMoveUpExecute(Sender: TObject);
    procedure acMoveDownExecute(Sender: TObject);
    procedure acReOrderExecute(Sender: TObject);
    procedure acSortAlphabeticallyExecute(Sender: TObject);
    procedure acRemoveExecute(Sender: TObject);
    procedure acAssignExecute(Sender: TObject);
    procedure acEditPairExecute(Sender: TObject);
    procedure acZeroAllExecute(Sender: TObject);
    procedure acZeroToNExecute(Sender: TObject);
    procedure pnlMainResize(Sender: TObject);
    procedure ActionList1Update(Action: TBasicAction; var Handled: Boolean);
  private
    fTerm: ITerm;
    fPairType: TTermComponentType;
    fTermType: TTermType;
    fCollapsed: boolean;
  public
    destructor Destroy; override;
  end;
function NewEditPairsFrame(aOwner: TWinControl; aTerm: ITerm; aPairType: TTermComponentType; aTermType: TTermType): TfraEditPairs;
implementation
uses
  uGlobalVars,
  uXML,
  fEditTermPairRanking,
  fEditConversion,
  fEditUnit,
  fEditChildTerm;
{$R *.dfm}
function NewEditPairsFrame(aOwner: TWinControl; aTerm: ITerm; aPairType: TTermComponentType; aTermType: TTermType): TfraEditPairs;
var
  i: integer;
begin
  Result := TfraEditPairs.Create(aOwner);
  with Result do
    begin
      pnlMain.DoubleBuffered := True;
      pnlAll.DoubleBuffered := True;
      fTerm := aTerm;
      fPairType := aPairType;
      fTermType := aTermType;
      fCollapsed := True;
      if aPairType = ctQualifier then
        lblType.Caption := TERM_TYPE_DISPLAY[fTermType]
      else
        lblType.Caption := TERM_COMPONENT_TYPE[fPairType];
      lblType.Font.Style := [fsBold];
      Name := Format('%s_%d', [Result.ClassName, aOwner.ComponentCount]);
      Top := aOwner.ControlCount * 200;
      Parent := aOwner;
      Align := alTop;
      MyTerminology.LoadList(lbxall.Items, aTermType);
      i := aTerm.getListIndex(lbxAll.Items);
      if i > -1 then
        lbxAll.Items.Delete(i);
      if lbxAll.Items.Count > 0 then
        lbxAll.ItemIndex := 0
      else
        lbxAll.Enabled := False;
      acLoadItems.Execute;
      acExpandCollapse.Execute;
      aOwner.Height := Top + Height;
    end;
end;
destructor TfraEditPairs.Destroy;
begin
  inherited;
end;
procedure TfraEditPairs.pnlMainResize(Sender: TObject);
begin
  pnlAll.Width := trunc(pnlMain.Width * 0.48);
end;
procedure TfraEditPairs.acExpandCollapseExecute(Sender: TObject);
begin
  fCollapsed := (not fCollapsed);
  if fCollapsed then
    begin
      Height := 25;
      ilMinusPlus.Draw(Image1.Canvas, 0, 0, 1);
      Image1.Invalidate;
    end
  else
    begin
      Height := 180;
      ilMinusPlus.Draw(Image1.Canvas, 0, 0, 0);
      Image1.Invalidate;
    end;
  pnlMain.Visible := (not fCollapsed);
end;
procedure TfraEditPairs.acLoadItemsExecute(Sender: TObject);
var
  i, j: integer;
  aItem1, aItem2: ITermComponent;
begin
  lbxSelected.Items.Clear;
  case fPairType of
    ctQualifier: fTerm.LoadComponents(lbxSelected.Items, fTermType, True);
  else
    fTerm.LoadComponents(lbxSelected.Items, fPairType, True);
  end;
  { Old School Sort by Component Order :) }
  if lbxSelected.Items.Count > 1 then
    for i := 0 to lbxSelected.Items.Count - 2 do
      for j := i to lbxSelected.Items.Count - 1 do
        begin
          lbxSelected.Items.Objects[i].GetInterface(ITermComponent, aItem1);
          lbxSelected.Items.Objects[j].GetInterface(ITermComponent, aItem2);
          if aItem1.getComponentOrder > aItem2.getComponentOrder then
            lbxSelected.Items.Exchange(i, j);
        end;
end;
procedure TfraEditPairs.acMoveUpExecute(Sender: TObject);
begin
  if lbxSelected.ItemIndex > -1 then
    if lbxSelected.ItemIndex > 0 then
      begin
        lbxSelected.Items.Exchange(lbxSelected.ItemIndex, lbxSelected.ItemIndex - 1);
        acReOrder.Execute;
      end;
end;
procedure TfraEditPairs.acMoveDownExecute(Sender: TObject);
begin
  if lbxSelected.ItemIndex > -1 then
    if lbxSelected.ItemIndex < (lbxSelected.Count - 1) then
      begin
        lbxSelected.Items.Exchange(lbxSelected.ItemIndex, lbxSelected.ItemIndex + 1);
        acReOrder.Execute;
      end;
end;
procedure TfraEditPairs.acRemoveExecute(Sender: TObject);
var
  aComp: ITermComponent;
  i: integer;
begin
  for i := lbxSelected.Items.Count - 1 downto 0 do
    if lbxSelected.Selected[i] then
      if lbxSelected.Items.Objects[i].GetInterface(ITermComponent, aComp) then
        begin
          fTerm.RemoveComponent(aComp);
          lbxSelected.Items.Delete(i);
        end;
  fTerm.setChangeMade(True);
end;
procedure TfraEditPairs.acReOrderExecute(Sender: TObject);
var
  i: integer;
  aComp: ITermComponent;
begin
  for i := 0 to lbxSelected.Items.Count - 1 do
    if lbxSelected.Items.Objects[i].GetInterface(ITermComponent, aComp) then
      aComp.setComponentOrder(i + 1);
  fTerm.setChangeMade(True);
end;
procedure TfraEditPairs.acZeroAllExecute(Sender: TObject);
var
  i: integer;
  aQual: ITermQualifierPair;
begin
  for i := 0 to lbxSelected.Items.Count - 1 do
    if lbxSelected.Items.Objects[i].GetInterface(ITermQualifierPair, aQual) then
      begin
        aQual.setRanking(0);
        lbxSelected.Items[i] := aQual.getComponentDisplayName;
      end;
  fTerm.setChangeMade(True);
end;
procedure TfraEditPairs.acZeroToNExecute(Sender: TObject);
var
  i: integer;
  aQual: ITermQualifierPair;
begin
  for i := 0 to lbxSelected.Items.Count - 1 do
    if lbxSelected.Items.Objects[i].GetInterface(ITermQualifierPair, aQual) then
      begin
        aQual.setRanking(i + 1);
        lbxSelected.Items[i] := aQual.getComponentDisplayName;
      end;
  fTerm.setChangeMade(True);
end;
procedure TfraEditPairs.acAssignExecute(Sender: TObject);
var
  aTerm: ITerm;
  aComp: ITermComponent;
  i: integer;
begin
  if lbxall.Items.Objects[lbxAll.ItemIndex].GetInterface(ITerm, aTerm) then
    begin
      {Check for inactives}
      if not aTerm.getActive then
        if MessageDlg(
          'The item ''' + aTerm.getterm + ''' is marked as inactive.' + #13 + #13 +
          'Are you sure you want to add this item?',
          mtConfirmation, [mbYes, mbNo], 0) = mrNo then
          Exit;
      {Check for duplicates}
      for i := 0 to lbxSelected.Items.Count - 1 do
        if lbxSelected.Items.Objects[i].GetInterface(ITermComponent, aComp) then
          if aComp.getComponentTerm.getID = aTerm.getID then
            begin
              MessageDlg('This item is already a component of this term', mtInformation, [mbOk], 0);
              Exit;
            end;
      if fTerm.NewComponent(fPairType, aTerm).QueryInterface(ITermComponent, aComp) = 0 then
        begin
          aComp.AddToList(lbxSelected.Items);
          acReOrder.Execute;
          lbxSelected.ItemIndex := lbxSelected.Items.Count - 1;
          acEditPair.Execute;
        end;
    end
  else
    MessageDlg('WOW, I can''t get an ITerm interface off of that one.', mtError, [mbOk], 0);
end;
procedure TfraEditPairs.acEditPairExecute(Sender: TObject);
var
  aTermComp: ITermComponent;
  aQualPair: ITermQualifierPair;
  aUnitConv: ITermUnitConversion;
  aUnitPair: ITermUnitPair;
  aTermPair: ITermChildPair;
  i: integer;
begin
  if lbxSelected.ItemIndex > -1 then
    begin
      i := lbxSelected.ItemIndex;
      lbxSelected.Items.Objects[lbxSelected.ItemIndex].GetInterface(ITermComponent, aTermComp);
      if aTermComp.QueryInterface(ITermQualifierPair, aQualPair) = 0 then
        EditTermPair(aQualPair);
      if lbxSelected.Items.Objects[i].GetInterface(ITermUnitConversion, aUnitConv) then
        EditConversion(aUnitConv);
      if aTermComp.QueryInterface(ITermUnitPair, aUnitPair) = 0 then
        EditUnit(aUnitPair);
      if lbxSelected.Items.Objects[i].GetInterface(ITermChildPair, aTermPair) then
        EditTermChild(aTermPair);
      lbxSelected.Items[i] := aTermComp.getComponentDisplayName;
      lbxSelected.Selected[i] := True;
      fTerm.setChangeMade(True);
    end;
end;
procedure TfraEditPairs.acSortAlphabeticallyExecute(Sender: TObject);
begin
  lbxSelected.Sorted := True;
  lbxSelected.Sorted := False;
  acReOrder.Execute;
end;
procedure TfraEditPairs.ActionList1Update(Action: TBasicAction; var Handled: Boolean);
begin
  if lbxSelected.SelCount = 1 then
    begin
      acMoveUp.Enabled := (lbxSelected.ItemIndex > 0);
      acMoveDown.Enabled := (lbxSelected.ItemIndex < (lbxSelected.Items.Count - 1));
    end
  else
    begin
      acMoveUp.Enabled := False;
      acMoveDown.Enabled := False;
    end;
  acSortAlphabetically.Enabled := (lbxSelected.Count > 1);
  lbxSelected.Enabled := (lbxSelected.Items.Count > 0);
  Handled := True;
end;
end.
