unit mTermList;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ComCtrls,
  iCPTerminology,
  ImgList,
  Menus;

type
  TfraTermList = class(TFrame)
    lvTerms: TListView;
    ilSmall: TImageList;
    ilLarge: TImageList;
    pmnView: TPopupMenu;
    pmnViewIcons: TMenuItem;
    pmnViewList: TMenuItem;
    pmnViewDetails: TMenuItem;
    procedure lvTermsDblClick(Sender: TObject);
    procedure lvTermsGetImageIndex(Sender: TObject; Item: TListItem);
    procedure pmnViewIconsClick(Sender: TObject);
    procedure pmnViewListClick(Sender: TObject);
    procedure pmnViewDetailsClick(Sender: TObject);
    procedure AutoArrange1Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure Load(aNode: TTreeNode);
  end;

function NewTermListFrame(aOwner: TWinControl): TfraTermList;

implementation

uses fMain;

{$R *.dfm}

function NewTermListFrame(aOwner: TWinControl): TfraTermList;
begin
  Result := TfraTermList.Create(aOwner);
  with Result do
    begin
      Font := Screen.IconFont;
      DoubleBuffered := True;
      Name := Format('%s_%d', [Result.ClassName, aOwner.ComponentCount]);
      Top := aOwner.ComponentCount * 20;
      Parent := aOwner;
      Align := alClient;
    end;
end;

procedure TfraTermList.AutoArrange1Click(Sender: TObject);
begin
  lvTerms.Arrange(arAlignTop);
end;

procedure TfraTermList.Load(aNode: TTreeNode);
var
  aTerm: ITerm;
  aTermNode: TTreeNode;
begin
  lvTerms.Items.Clear;
  aTermNode := aNode.getFirstChild;
  while Assigned(aTermNode) do
    try
      if TObject(aTermNode.Data).GetInterface(ITerm, aTerm) then
        with lvTerms.Items.Add do
          begin
            Caption := aTerm.getTerm;
            SubItems.Add(aTerm.getAbbreviation);
            SubItems.Add(aTerm.getDisplayName);
            SubItems.Add(aTerm.getVUID);
            Data := aTermNode;
          end;
    finally
      aTermNode := aTermNode.getNextSibling;
    end;
end;

procedure TfraTermList.lvTermsDblClick(Sender: TObject);
var
  aNode: TTreeNode;
begin
  if lvTerms.Selected <> nil then
    if TObject(lvTerms.Selected.Data).ClassNameIs('TTreeNode') then
      begin
        aNode := TTreeNode(lvTerms.Selected.Data);
        frmMain.tv.Selected := aNode;
      end;
end;

procedure TfraTermList.lvTermsGetImageIndex(Sender: TObject; Item: TListItem);
var
  aTerm: ITerm;
begin
  if Item.Data <> nil then
    if TObject(Item.Data).ClassNameIs('TTreeNode') then
      if TObject(TTreeNode(Item.Data).Data).GetInterface(ITerm, aTerm) then
        if aTerm.getActive then
          begin
            if aTerm.getComponentCount(ctError) = 0 then
              Item.ImageIndex := 0
            else
              Item.ImageIndex := 2
          end
        else
          Item.ImageIndex := 1;
end;

procedure TfraTermList.pmnViewDetailsClick(Sender: TObject);
begin
  lvTerms.ViewStyle := vsReport;
end;

procedure TfraTermList.pmnViewIconsClick(Sender: TObject);
begin
  lvTerms.ViewStyle := vsIcon;
end;

procedure TfraTermList.pmnViewListClick(Sender: TObject);
begin
  lvTerms.ViewStyle := vsList;
end;

end.

