unit oTermComponentEnumerator;

interface

uses
  Classes,
  SysUtils,
  iCPTerminology;

type
  TTermComponentEnumerator = class(TInterfacedObject, ITermComponentEnumerator)
  private
    fList: IInterfaceList;
    fIndex: integer;
    fType: TTermComponentType;
  public
    constructor Create(aList: IInterfaceList; aType: TTermComponentType);
    destructor Destroy; override;

    function GetCurrentIndex: integer; stdcall;
    function GetPercentageDone: integer; stdcall;
    function GetCurrentComponent: ITermComponent; stdcall;
    function MoveNext: boolean; stdcall;
  end;

implementation

{ TTermComponentEnumerator }

constructor TTermComponentEnumerator.Create(aList: IInterfaceList; aType: TTermComponentType);
begin
  inherited Create;
  fList := aList;
  fIndex := -1;
  fType := aType;
end;

destructor TTermComponentEnumerator.Destroy;
begin
  inherited;
end;

function TTermComponentEnumerator.GetCurrentComponent: ITermComponent;
begin
  fList[fIndex].QueryInterface(ITermComponent, Result);
end;

function TTermComponentEnumerator.GetCurrentIndex: integer;
begin
  Result := fIndex;
end;

function TTermComponentEnumerator.GetPercentageDone: integer;
begin
  Result := trunc((fIndex / fList.Count) * 100);
end;

function TTermComponentEnumerator.MoveNext: boolean;
begin
  Result := False;
  if fIndex >= (fList.Count - 1) then
    Result := False
  else
    if fType = ctUnknown then
      begin
        Result := fIndex < (fList.Count - 1);
        if Result then
          Inc(fIndex);
      end
    else
      while fIndex < (fList.Count - 1) do
        begin
          inc(fIndex);
          if (fList[fIndex] as ITermComponent).getComponentType = fType then
            begin
              Result := True;
              Exit;
            end;
          Result := False;
        end
end;

end.

