unit fMain;
================================================================================
*       Application:  Clinical Observations
*       Revision:     $Revision: 3 $  $Modtime: 2/15/08 2:14p $
*       Developer:      
*       Site:         Hines OIFO
*       Description:  Developer unit.
*       Notes:
================================================================================
*       $Archive: /CP Modernization/CliO/source/TLookupFrame/fMain.pas $
* $History: fMain.pas $
 * 
 * *****************  Version 3  *****************
 * User: Vhaishpetitd Date: 2/16/08    Time: 4:04p
 * Updated in $/CP Modernization/CliO/source/TLookupFrame
 * 
 * *****************  Version 2  *****************
 * User: Vhaishpetitd Date: 12/11/06   Time: 2:00p
 * Updated in $/CP Modernization/CliO/source/TLookupFrame
 * Demo released to testing and documentation
 *
 * *****************  Version 1  *****************
 * User: Vhaishpetitd Date: 10/05/06   Time: 1:04p
 * Created in $/CP Modernization/CliO/source/TLookupFrame
 * Initial Check-In
 *
================================================================================
interface
uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  XPMan,
  mLookup,
  ExtCtrls;
type
  TfrmMain = class(TForm)
    Button1: TButton;
    Label2: TLabel;
    ScrollBox1: TScrollBox;
    fraLookup1: TfraLookup;
    procedure FormCreate(Sender: TObject);
    procedure DoVistALookup(aFile, aPartial: string; aCount: integer; aList: TStrings);
    procedure DoVistAHelp(aFile: string);
    procedure Button1Click(Sender: TObject);
  private
    MyLookup: TfraLookup;
    procedure GetOption(aPartial: string; aResult: TStringList);
    procedure GetOptionHelp;
    procedure GetInstitution(aPartial: string; aResult: TStrings);
    procedure GetInstitutionHelp;
    procedure GetNewPerson(aPartial: string; aResult: TStringList);
    procedure GetNewPersonHelp;
    procedure GetPatient(aPartial: string; aResult: TStringList);
    procedure GetPatientHelp;
    procedure GetInstrument(aPartial: string; aResult: TStringList);
    procedure GetInstrumentHelp;
    { Private declarations }
  public
    { Public declarations }
  end;
var
  frmMain: TfrmMain;
implementation
{$R *.dfm}
uses
  TRPCB;
var
  MyBroker: TRPCBroker;
procedure TfrmMain.FormCreate(Sender: TObject);
begin
  Font := Screen.IconFont;
  DeleteFile('.\objects.ini');
  DoubleBuffered := True;
  MyBroker := TRPCBroker.Create(Self);
  MyBroker.Server := 'localhost';
  MyBroker.ListenerPort := 9205;
  MyBroker.AccessVerifyCodes := 'L;L';
  MyBroker.Connected := True;
  fraLookup1.Initialize('', '', GetInstitution, GetInstitutionHelp);
  //MyLookup := NewFraLookup(Panel1);
  //MyLookup.Left := 0;
  //MyLookup.Top := 0;
  //fraLookup2.Initialize('', '', GetOption, GetOptionHelp);
  //fraLookup3.Initialize('', '', GetPatient, GetPatientHelp);
  //fraLookup4.Initialize('', '', GetNewPerson, GetNewPersonHelp);
  //fraLookup5.Initialize('', '', GetInstrument, GetInstrumentHelp);
end;
procedure TfrmMain.DoVistAHelp(aFile: string);
begin
  with MyBroker do
    begin
      RemoteProcedure := 'ZZDRP';
      Param[0].Value := 'FMHELP';
      Param[0].PType := literal;
      Param[1].Value := aFile;
      Param[1].PType := literal;
      Call;
      if Results.Count > 1 then
        begin
          Results.Delete(0); {fm help returns a line count}
          MessageDlg(Results.Text, mtInformation, [mbOk], 0);
        end
      else
        MessageDlg('No help text found in the fileman definition', mtWarning, [mbOk], 0);
    end;
end;
procedure TfrmMain.DoVistALookup(aFile, aPartial: string; aCount: integer; aList: TStrings);
var
  i: integer;
  obj: TFetchItem;
begin
  with MyBroker do
    begin
      RemoteProcedure := 'ZZDRP';
      Param[0].Value := 'FMLKUP';
      Param[0].PType := literal;
      Param[1].Value := aFile;
      Param[1].PType := literal;
      Param[2].Value := aPartial;
      Param[2].PType := literal;
      if aCount > 0 then
        Param[3].Value := IntToStr(aCount)
      else
        Param[3].Value := '*';
      Param[3].PType := literal;
      lstCall(aList);
    end;
  if aList.Count > 1 then {Convert to objects and pointers}
    for i := 1 to aList.Count - 1 do
      begin
        obj := TFetchItem.Create;
        obj.InternalValue := Copy(aList[i], 1, Pos('^', aList[i]) - 1); // IntToStr(i);
        obj.ExternalValue := Copy(aList[i], Pos('^', aList[i]) + 1, Length(aList[i])); //Format('%s_%d', [aPartial, i]);
        aList[i] := Copy(aList[i], Pos('^', aList[i]) + 1, Length(aList[i]));
        aList.Objects[i] := obj;
      end;
  {Now purge the counter node}
  aList.Delete(0);
end;
procedure TfrmMain.GetOption(aPartial: string; aResult: TStringList);
begin
  DoVistALookup('19', aPartial, 100, aResult);
end;
procedure TfrmMain.GetOptionHelp;
begin
  DoVistAHelp('19');
end;
procedure TfrmMain.GetInstitution(aPartial: string; aResult: TStrings);
begin
  DoVistALookup('4', aPartial, 100, aResult);
end;
procedure TfrmMain.GetInstitutionHelp;
begin
  DoVistAHelp('4');
end;
procedure TfrmMain.GetNewPerson(aPartial: string; aResult: TStringList);
begin
  DoVistALookup('200', aPartial, 100, aResult);
end;
procedure TfrmMain.GetNewPersonHelp;
begin
  DoVistAHelp('200');
end;
procedure TfrmMain.GetPatient(aPartial: string; aResult: TStringList);
begin
  DoVistALookup('2', aPartial, 100, aResult);
end;
procedure TfrmMain.GetPatientHelp;
begin
  DoVistAHelp('2');
end;
procedure TfrmMain.GetInstrument(aPartial: string; aResult: TStringList);
begin
  DoVistALookup('702.09', aPartial, 0, aResult);
end;
procedure TfrmMain.GetInstrumentHelp;
begin
  DoVistAHelp('702.09');
end;
procedure TfrmMain.Button1Click(Sender: TObject);
begin
  ShowMessage(
    Format(
    'Internal = %s' + #13 + 'External = %s',
    [fraLookup1.InternalValue, fraLookup1.ExternalValue]));
end;
end.
