unit oWidget;
================================================================================
*       Application:  Clinical Observations
*       Revision:     $Revision: 7 $  $Modtime: 5/26/09 12:42p $
*       Developer:      
*       Site:         Hines OIFO
*       Description:  Proof of Concept
*       Notes:
================================================================================
*       $Archive: /CP Modernization/CliO/source/TGridFrame/oWidget.pas $
* $History: oWidget.pas $
 * 
 * *****************  Version 7  *****************
 * User: Vhaishjuergb Date: 5/28/09    Time: 10:53a
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * Build 275
 * 
 * *****************  Version 6  *****************
 * User: Vhaishpetitd Date: 6/13/08    Time: 4:14p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * 
 * *****************  Version 5  *****************
 * User: Vhaishpetitd Date: 8/08/07    Time: 10:53a
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * 
 * *****************  Version 4  *****************
 * User: Vhaishpetitd Date: 2/23/07    Time: 1:59p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * Post CMO conference
 *
 * *****************  Version 3  *****************
 * User: Vhaishpetitd Date: 11/09/06   Time: 3:04p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * Weekly update of all changes.
 *
 * *****************  Version 2  *****************
 * User: Vhaishpetitd Date: 10/23/06   Time: 4:07p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * Finished Pivots, Parser Key, and Totals.
 *
 * *****************  Version 1  *****************
 * User: Vhaishpetitd Date: 10/05/06   Time: 1:02p
 * Created in $/CP Modernization/CliO/source/TGridFrame
 * Initial Check-In
 *
================================================================================
interface
uses
  Classes,
  SysUtils,
  Graphics,
  iCliOGrid;
type
  IWidget = interface
    ['{51FFD4AB-5194-4780-93E1-EA09BB99EF8E}']
    function getDateTime: TDateTime; stdcall;
    function getDisplayValue: string; stdcall;
    function getTermName: string; stdcall;
  end;
  TWidget = class(TInterfacedObject, IWidget, IGridItem)
  private
    fDateTime: TDateTime;
    fTermName: string;
    fValue: string;
  protected
    function _AddRef: integer; stdcall;
    function _Release: integer; stdcall;
  public
    constructor Create;
    destructor Destroy; override;
    function getDateTime: TDateTime; stdcall;
    function getTermName: string; stdcall;
    function getDisplayValue: string; stdcall;
    function getNumericValue: double; stdcall;
    function getDisplayFontStyle: TFontStyles; stdcall;
    function getDisplayFontColor: TColor; stdcall;
    function getDisplayFlag: TGridFlag; stdcall;
  end;
function NewWidget(aDateTime: TDateTime; aTermName: string; aValue: string): IWidget;
implementation
function NewWidget(aDateTime: TDateTime; aTermName: string; aValue: string): IWidget;
begin
  with TWidget.Create do
    begin
      fDateTime := aDateTime;
      fTermName := aTermName;
      fValue := aValue;
      GetInterface(IWidget, Result)
    end;
end;
constructor TWidget.Create;
begin
  inherited Create;
end;
destructor TWidget.Destroy;
begin
  inherited;
end;
{ TWidget }
function TWidget._AddRef: integer;
begin
  result := inherited _AddRef;
end;
function TWidget._Release: integer;
begin
  result := inherited _Release;
end;
function TWidget.getDateTime: TDateTime;
begin
  Result := fDateTime;
end;
function TWidget.getDisplayValue: string;
begin
  Result := fValue;
end;
function TWidget.getTermName: string;
begin
  Result := fTermName;
end;
function TWidget.getNumericValue: double;
begin
  Result := StrToFloatDef(fValue, 0.0);
end;
function TWidget.getDisplayFlag: TGridFlag;
begin
 Result := gfNone;
end;
function TWidget.getDisplayFontColor: TColor;
begin
  Result := clWindowText;
end;
function TWidget.getDisplayFontStyle: TFontStyles;
begin
  Result := [fsItalic,fsBold];
end;
end.
